Dim Delay, UserName, PassWord, ChromeLaunch, Daemon, ConfigFile, ShortcutURL

ConfigFile = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\config.txt"
SetConfigFromFile(ConfigFile)

Dim count, oldCount
count = 0
oldCount = -1


Do
	Get_Count()
	'WScript.Echo(count)

	If count <> oldCount Then
		'WScript.Echo("In loop")
		If count > 999 Then
			count = 1000
		End If

		Create_Icon()

		Create_Shortcut()
		
		oldCount = count
	End If

	If Daemon = "true" Then
        	WScript.Sleep Delay*1000
        End If
Loop Until Daemon = "false"


'Read config file
Sub SetConfigFromFile(fileName)
	Set fso = CreateObject("Scripting.FileSystemObject")
	DIM strConfigLine,fConFile,EqualSignPosition, strLen, VariableName, VariableValue
	SET fConFile = fso.OpenTextFile(fileName)
	WHILE NOT fConFile.AtEndOfStream
		strConfigLine = fConFile.ReadLine
		strConfigLine = TRIM(strConfigLine)
		IF (INSTR(1,strConfigLine,"#",1) <> 1 AND LEN(strConfigLine) <> 0) THEN
			'msgbox(strConfigLine)
			EqualSignPosition = INSTR(1,strConfigLine,"=",1)
			strLen = LEN(strConfigLine)
			VariableName = LCASE(TRIM(MID(strConfigLine, 1, EqualSignPosition-1))) 'line 34
			VariableValue = TRIM(Mid(strConfigLine, EqualSignPosition + 1, strLen - EqualSignPosition))
			SELECT CASE VariableName
				'ADD EACH OCCURRENCE OF THE CONFIGURATION FILE VARIABLES(KEYS)
				CASE LCASE("Delay")
					IF VariableValue <> "" THEN Delay = VariableValue
				CASE LCASE("ChromeLaunch")
					IF VariableValue <> "" THEN ChromeLaunch = VariableValue
				CASE LCASE("UserName")
					IF VariableValue <> "" THEN UserName = VariableValue
				CASE LCASE("PassWord")
					IF VariableValue <> "" THEN PassWord = VariableValue
				CASE LCASE("Daemon")
					IF VariableValue <> "" THEN Daemon = VariableValue
				CASE LCASE("ShortcutURL")
					IF VariableValue <> "" THEN ShortcutURL = VariableValue
			END SELECT
		END IF
	WEND
	fConFile.Close
End Sub


' Get the count
Private Sub Get_Count()
	Set objHTTP = CreateObject("MSXML2.XMLHTTP") 
	Call objHTTP.Open("GET", "https://mail.google.com/mail/feed/atom", False, UserName, PassWord) 
	'objHTTP.setRequestHeader "Authorization", "GoogleLogin auth="+Sid
	objHTTP.send
	UnreadXml = objHTTP.ResponseText

	Dim doc
	Dim objNodeList

	Set doc = CreateObject("MSXML2.DOMDocument")
	doc.loadXML(UnreadXml) 

	Set objNodeList = doc.documentElement.selectNodes("//fullcount")
	count = objNodeList.item(0).text
End Sub


' Create shortcut code
Private Sub Create_Shortcut()
	Set WshShell = CreateObject("WScript.Shell")
	strDesktopPath = WshShell.SpecialFolders("Desktop")
	'strDesktopPath = "C:\Users\ben.curtis\AppData\Roaming\Microsoft\Internet Explorer\Quick Launch\User Pinned\TaskBar"

	Set objShortcutUrl = WshShell.CreateShortcut(strDesktopPath & "\Gmail.lnk")
	
	If ChromeLaunch = "true" Then
		objShortcutUrl.TargetPath = "%USERPROFILE%\AppData\Local\Google\Chrome\Application\chrome.exe"
		objShortcutUrl.Arguments = "--app=" & ShortcutURL
	Else
		objShortcutUrl.TargetPath = ShortcutURL
	End If
	
	Dim iconPath
	iconPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\dynamic\Gmail-" & count & ".ico"
	'WScript.Echo(iconPath)
	objShortcutUrl.IconLocation = iconPath
	objShortcutUrl.Save 
End Sub


' Use ImageMagick to create new icon (http://www.imagemagick.org/script/binary-releases.php#windows dll version)
Private Sub Create_Icon()
	set img = CreateObject("ImageMagickObject.MagickImage.1")
	set fso = CreateObject("Scripting.FileSystemObject")
	
	Dim originalPath, iconPath
	iconPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\dynamic\Gmail-" & count & ".ico"

	If Not fso.FileExists(iconPath) Then
		If count = 0 Then	
			originalPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\source\0.png"
			img.Convert originalPath, iconPath
		ElseIf count < 10 Then	
			originalPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\source\2.png"
			img.Convert originalPath, "-fill", "white", "-gravity", "southwest", "-font", "arial bold", "-pointsize", "40", "-draw", "text 82,79 '" & count & "'", iconPath
		ElseIf count < 100 Then
			originalPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\source\2.png"
			img.Convert originalPath, "-fill", "white", "-gravity", "southwest", "-font", "arial bold", "-pointsize", "40", "-draw", "text 72,79 '" & count & "'", iconPath
		ElseIf count < 1000 Then
			originalPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\source\3.png"
			img.Convert originalPath, "-fill", "white", "-gravity", "southwest", "-font", "arial bold", "-pointsize", "40", "-draw", "text 50,79 '" & count & "'", iconPath
		Else
			originalPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\icons\source\4.png"
			img.Convert originalPath, "-fill", "white", "-gravity", "southwest", "-font", "arial bold", "-pointsize", "40", "-draw", "text 31,79 '999+'", iconPath
		End If

		img.Convert iconPath, "(", "-clone", "0", "-resize", "8x8", ")", "(", "-clone", "0", "-resize", "10x10", ")", "(", "-clone", "0", "-resize", "14x14", ")", "(", "-clone", "0", "-resize", "16x16", ")", "(", "-clone", "0", "-resize", "22x22", ")", "(", "-clone", "0", "-resize", "24x24", ")", "(", "-clone", "0", "-resize", "32X32", ")", "(", "-clone", "0", "-resize", "40x40", ")", "(", "-clone", "0", "-resize", "48x48", ")", "(", "-clone", "0", "-resize", "64x64", ")", "(", "-clone", "0", "-resize", "96x96", ")", "(", "-clone", "0", "-resize", "128x128", ")", "-delete", "0", "-alpha", "on", "-channel", "RGBA", iconPath
	End If
End Sub

Public Function TimeStamp()
    TimeStamp = CLng(Timer * 100)
End Function

